/* Game.C <-- The game indeed. */

#include "boxes.h"
#include "../src/operations.h"

void the_board::bomb_check (void) {
    if (!finished)
	_bomb_check(0);
   if (cracked==total && Xsize*Ysize>uncovered+cracked) {
	   for (int cy = 0; cy < Ysize; cy++)
		   for (int cx = 0; cx < Xsize; cx++)
		   {
			   if (!seen(XY(cx,cy))) 
			   seen(XY(cx,cy),1);
			   box_put (XY(cx,cy),*this);
		   }
	   winner();
   }
}
/* magic:
   0 - normalnie odkryj
   1 - analizuj pole
   2 - analizuj pola naokolo
 */

void the_board::_bomb_check (int magic) {
   int around_P = 0; 
   int around_S = 0; //around seen
   int around_N = 0; //around not seen
   XY pos;

   if ( ! generated ) generate ();
   if (defaults.ai)
   {
      if ( (magic!=2 && (autorec() || autorec2())))
	 return;
      if ((free() || (seen() && num() == 9)) && (magic==0 || magic==1) ) //nie ma byc magic!=2, bo nie wiem czy nie dodam magic=3
	 return;
      
      if (magic==0&&!finished) { 
	 if (seen ( 1 )) { return; }
	 _bomb_check(1);
	 _bomb_check(2);
      } else if (magic==1&&!finished) {
	 for (int cx = 1; cx <= 9; cx++) {
	    if (cx==5) continue;
	    pos = cursor.move (*this, cx, surf2move(defaults.surface)); // zeby dzialalo dla Kleina
	    if (pos.x >= 0 ) {
	       if ( !seen(pos) && !free(pos) )
		  around_N++;
	       else if ( seen(pos) && num(pos) < 9) //jezeli num==9 => juz wczesniej przegrales
		  around_S++;
	       else if (free(pos) || (seen(pos) && num(pos)==9))
		  around_P++;
	    }
	 }

	 if (num() == around_P) { //wszystkie miny naokolo znalezione
	    autorec ( 1 );
	    for (int cx = 1; cx <= 9; cx++) {
	       pos=cursor.move(*this, cx,surf2move(defaults.surface));
	       if (pos.x<0 || cx==5) continue;
	       if (!free(pos) && !seen(pos))
	       {
		  box_move_hidden(cx,*this);
		  _bomb_check(0);
		  if (finished)
			  return;
		  box_move_hidden(-cx,*this);
	       }
	    }
	 } else if (num()-around_P==around_N) { //wszystkie puste naokolo znalezione
	    autorec ( 1 );
	    for (int cx = 1; cx <= 9; cx++) {
	       if (cursor.move(*this, cx,surf2move(defaults.surface)).x<0) continue;
	       box_move_hidden(cx,*this);
	       if (! (seen() | free()) ) { 
		  free ( 1 );
	       }
	       box_move_hidden(-cx,*this);
	    }
	 }
	 autorec2(1);
      } else if (magic==2&&!finished) {
	 for (int cy = 1; cy <= 9; cy++) {
	    pos=cursor.move(*this, cy,surf2move(defaults.surface));
	    if (pos.x<0 || cy==5) continue;
	    if (seen(pos)==1)
	       autorec2(pos,0);
	 }
	 for (int cy = 1; cy <= 9; cy++) {
	    if (cursor.move(*this, cy,surf2move(defaults.surface)).x<0 || cy==5) continue;
	    box_move_hidden(cy,*this);
	    if (seen()==1) {
	       _bomb_check(1);
	       if (finished)
		       return;
	    }
	    box_move_hidden(-cy,*this);
	 }
      }
   }
   else 
   {
      if (autorec()==0) {
	 if (seen(1)) return;
	 if (num()==0) {
	    autorec(1);
	    for (int cy = 1; cy <= 9; cy++) {
	       if (cursor.move(*this, cy,surf2move(defaults.surface)).x<0 || cy==5) continue;
	       box_move_hidden(cy,*this);
	       _bomb_check(0);
	       if (finished)
		       return;
	       box_move_hidden(-cy,*this);
	    }
	 }
      }
   }
return;
}

void the_board::bomb_free (void)
  {
  if ( seen() == 0 ) {
     free ( ! free() );
     refresh_all();
  }
  }

