/****************************************************************************/
/*                              minesweep vX.0.12                           */
/*                the popular minesweep game now in text form               */
/****************************************************************************/

#include "../src/init.h"
#include "boxes.h"
#include "../src/input.h"
#include "args.h"

the_board game;

int main (int argc, char **argv)
  {   
  int char_got;
  
  if (!handle_args (argc, (const char **) argv, game.defaults)) return -1; 

  game.newstart();

  while (!game.defaults.quit)
    {
    char_got = -1; 
    game.finished=0;
    if (pressed_key())   
        char_got = char_get(game.win());
    
    game.footer.time_update(game);	// update time in statusbar
    game.winner();    
    if (char_got > 0 && char_got < 10) box_move (char_got, game);
    switch (char_got) 
      {
      case 0: 
	game.bomb_check(); 
	game.refresh_all();
      break;
      case 16: 
        game.bomb_free(); 
      break;
      case 64: game.defaults.quit = 1; break;
      case 128: game.defaults.quit = game.pause(); break;
      }
    
    napms(20);
    }
    
  end ();
  
  }

/* Copyright by FHF 2004 */
