/* Init.C <-- NCurses initialization. */

#include <ncurses.h>
#include <time.h>
#include <stdlib.h>
#include "input.h"

void init_colors (void)		
 {
 init_pair (0,  COLOR_BLACK,	COLOR_CYAN);
 init_pair (1,  COLOR_BLUE,	COLOR_CYAN);
 init_pair (2,  COLOR_GREEN,	COLOR_CYAN);
 init_pair (3,  COLOR_RED,	COLOR_CYAN);
 init_pair (4,  COLOR_CYAN,	COLOR_CYAN);
 init_pair (5,  COLOR_YELLOW,	COLOR_CYAN);
 init_pair (6,  COLOR_RED,	COLOR_CYAN);
 init_pair (7,  COLOR_WHITE,	COLOR_CYAN); 
 init_pair (8,  COLOR_MAGENTA,	COLOR_CYAN); 
 init_pair (9,  COLOR_BLACK,	COLOR_RED);
 init_pair (10, COLOR_BLUE,	COLOR_RED); 
 }
 
void start (void)
  { 
  initscr	(); 
  curs_set	(0);
  noecho	(); 
  cbreak	();
  timeout	(0);
  start_color	();
  init_colors	();
  srand		(time (NULL));
  open_keyboard ();
  }

void end (void)
  { 
  clear		();  
  refresh	(); 
  endwin	(); 
  exit		(0); 
  close_keyboard();
  }

/* Copyright by FHF 2004 */
