/* ClassTheboard.C <-- class the_board definitions. */

#include "classes.h"


int the_board::num (XY in)
 { return board[in.y][in.x].num; }
bool the_board::seen (XY in)
 { return board[in.y][in.x].seen; }
bool the_board::free (XY in)
 { return board[in.y][in.x].free; }
bool the_board::autorec	(XY in)
 { return board[in.y][in.x].autorec; }
bool the_board::autorec2 (XY in)
 { return board[in.y][in.x].autorec2; }

int the_board::num (void)
 { return num(cursor); }
bool the_board::seen (void)
 { return seen(cursor); }
bool the_board::free (void)
 { return free(cursor); }
bool the_board::autorec	(void)
 { return autorec(cursor); }
bool the_board::autorec2 (void)
 { return autorec2(cursor); }
 
void the_board::num (XY inXY, int in)
 { board[inXY.y][inXY.x].num = in; }
bool the_board::seen (XY inXY, bool in)
 { 
 if (board[inXY.y][inXY.x].seen != in)
    uncovered += (board[inXY.y][inXY.x].seen) ? -1 : 1;
 board[inXY.y][inXY.x].seen = in; 
   if (num(inXY)==9) { finish(); return 1; } 
 return 0;
 } 
void the_board::free (XY inXY, bool in)
 { 

if (board[inXY.y][inXY.x].free != in)
    {
    board[inXY.y][inXY.x].free = in; 
    cracked += (board[inXY.y][inXY.x].free) ? 1 : -1;
    if (in&&defaults.ai&&!finished) {
	_bomb_check(2);
     }
    }
} 
void the_board::autorec (XY inXY, bool in)
 { board[inXY.y][inXY.x].autorec = in; }
void the_board::autorec2 (XY inXY, bool in)
 { board[inXY.y][inXY.x].autorec2 = in; }
void the_board::force (XY inXY, bool in)
 { board[inXY.y][inXY.x].seen = in; }
 
void the_board::num (int in)
 { num(cursor,in); }
bool the_board::seen (bool in)
 { return seen(cursor,in); }
void the_board::free (bool in)
 { free(cursor,in); } 
void the_board::autorec (bool in)
 { autorec(cursor,in); }
void the_board::autorec2 (bool in)
 { autorec2(cursor,in); }
 
WINDOW* the_board::win (void)
 {
 return windows[cursor.y][cursor.x];
 }

WINDOW* the_board::win (XY in)
 {
 return windows[in.y][in.x];
 }
 
/* Copyright by FHF 2004 */
