/* Defines.h */

#include <math.h>
#include <ncurses.h>

#define VERSION		"X.0.12pre7"
#define DATE		"2004 Sep 3"

const chtype HS	= '#'; // HaSh
const chtype HSB = HS|A_BOLD; // HaSh in Bold
const chtype SP	= ' ';

#define UR  acs_map[(int) 'k'] // UpRight
#define UL  acs_map[(int) 'l'] // UpLeft
#define DR  acs_map[(int) 'j'] // DownRight
#define DL  acs_map[(int) 'm'] // DownLeft

#define RL  acs_map[(int) 'q'] // RightLeft
#define UD  acs_map[(int) 'x'] // UpDown

#define TU  acs_map[(int) 'v'] // T Up
#define TD  acs_map[(int) 'w'] // T Down
#define TR  acs_map[(int) 't'] // T Right
#define TL  acs_map[(int) 'u'] // T Left
#define PL  acs_map[(int) 'n'] // Plus

/* Copyright by FHF 2004 */



