/* Operations.C <-- Operations on numbers */

#include "../saper/classes.h"

void bomb_inc (int& incr)
 { if (incr < 8) incr ++; }

/* Module in/de crementation */
int crement(int alpha, int mod, int sign)  {
	alpha += sign;
	while ( alpha >= mod)
		 alpha -= mod;
	while ( alpha < 0 )
		  alpha += mod;
	return alpha;
}
 
void incr(int& alpha, int mod) {
	alpha = crement(alpha,mod,1);
}

void decr(int& alpha, int mod) {
	alpha = crement(alpha,mod,-1);
}

int where2pos (int where, the_board &game) {
	if(where<0) where+=10;
	if(game.defaults.surface == 1 || game.orient == 0) return where;
	switch (where) {
		case 1: where=3; break;
		case 3: where=1; break;
		case 7: where=9; break;
		case 9: where=7; break;    
	}
	return where;
}
 
int surf2move (int surface) {	// surface --> arg do move'a przy przesuwaniu "hardewarowym"
	switch (surface) {
		case 1: return 1;
		case 2: return 3;
		case 3: return 0;
	}
	return -1;
}

int surf2curs (int surface) {   // surface --> arg do move'a przy przesuwaniu kursora
	switch (surface) {
		case 1: return 0;
		case 2: return 2;
		case 3: return 0;
	}
	return -1;
}

/* Copyright by FHF 2004 */
